<?php

///////////////////////////////////////////////////////////
// PhpSaveIPX : script php                               //
// permettant la sauvegarde automatique                  //
// des donnes et de la configuration                    //
// des matriels GCE                                     //
// (IPX800, EcoDevice, EcoDevice RT2,... )               //
//  @fgtoul 2018   pour la communaut                    //
///////////////////////////////////////////////////////////


// Tableau $materiel avec les IPX800 V3, IPX800 V4, EDRT2
// structure d'une table  n matriels
// $materiel[0..n][0]: nom du matriel
// $materiel[0..n][1]: Type de matriel (IPX800V3, IPX800V4, EDRT2, ED),
// $materiel[0..n][2]: adresse IP locale ou distante,
// $materiel[0..n][3]: port TCP,
// $materiel[0..n][4]: securisation interface administrateur(true/false),
// $materiel[0..n][5]: utilisateur administrateur,
// $materiel[0..n][6]: password administrateur,
// $materiel[0..n][7]: nombre de cycles de sauvegarde  conserver. Illimit si 0

//remarque : si un seul matriel, ne laisser qu'une ligne et supprimer la virgule qui la termine
//           si plusieurs matriels, chaque ligne doit se terminer par une virgule, sauf la dernire

$materiel=array
			(
			array('IPX800_1','IPX800V4','192.168.0.112','80',false,'admin','',3),
			array('IPX800_2','IPX800V4','192.168.0.112','80',false,'admin','',3),
			array('PISCINE','IPX800V3','192.168.0.43','80',false,'admin','',5),
			array('EDRT','EDRT2','192.168.0.44','80',false,'admin','',3),
			array('ED','ED','192.168.0.44','80',false,'admin','',3)
			);
			

//sous-dossier temporaire pour download des fichiers sur le NAS
// ce sous-dossier sera cr dans le rpertoire web de cette application
$dwnload="sauvegardesGCE";

// dossier de destination des sauvegardes (les sous-dossiers y seront crs).
// ce dossier doit exister au pralable et doit permettre  tout le monde de lire/crire/excuter -> chmod(0777)
$destination="/volume1/test_savIPX"; //dossiers de destination des sauvegardes. renseigner le chemin absolu (complet)



// par dfaut, un jeu de sauvegarde rput incomplet (ayant rencontr des erreurs pendant son droulement)  ne sera pas prserv 
// et sera remplac lors du cycle suivant.
// si vous souhaitez prserver les jeux incomplets, passez le paramtre ci-dessous  true. 
// Dans ce cas, il est conseill de rgler la rtention  0 pour tous les matriels dans la table $materiel
$preserveIncomplets=false; //true ; false;

//Notifications
$NotificationsMail=true; //true : envoie d'un mail  la fin du traitement
$NotificationsLimitees=true; //si activs, les mails seront envoys uniquement lorsque le script se terminera avec des erreurs.
$NotificationsDestinataire="destinataire@gmail.com";

//********************************************************************************************************************
//********************************************************************************************************************
//********************************************************************************************************************
// ne rien modifier sous cette ligne 
//********************************************************************************************************************


// Tableau $fichiersXML contient le nom (sans extension) des fichiers XML  sauvegarder, par type de matriel
// structure d'une table  n types de matriels
// $fichiersXML[0..n][0] : chemin
// $fichiersXML[0..n][1] : type
// $fichiersXML[0..n][2..999] : nom du fichier

$fichiersXML=array
			(
			'IPX800V4'=>array('/admin/','status', 'io', 'graph', 'analog'),
			'IPX800V3'=>array('/','status', 'globalstatus'),
			'EDRT2'=>array('/admin/','status'),
			'ED'=>array('/','status')
			);
			
// Tableau $fichiersConfig contient le nom (sans extension) des fichiers de configuration  sauvegarder, par type de matriel
// structure d'une table  n types de matriels
// $fichiersConfig[0..n][0] : /chemin/
// $fichiersConfig[0..n][1] : type
// $fichiersConfig[0..n][2] : nom du fichier
// $fichiersConfig[0..n][3] : extension

$fichiersConfig=array
			(
			'IPX800V4'=>array('/admin/download/','config','gce'),
			'IPX800V3'=>array('/protect/download/','config','gce'),
			'EDRT2'=>array('/admin/download/','config','gce'),
			'ED'=>array('/protect/download/','config','gce')
			);
			


//gestionnaire d'erreurs
$erreurs=false; //gestionnaire d'erreurs => global script
$detailsExecutionErreurs='';
$avertissements=0;//gestionnaire d'avertissements => global script
set_time_limit(0);

//faonnage des donnes d'xcution (contenu web)
$detailsExecution='';


////////////////////////////////////////////////////////////////////////////////
//initialisation  0 des cycles pour tous les types de matriels 
// permet l'initialisation en cas de nouveau matriel dans la table $materiels
$cycles=array();
for ($i = 0; $i < count($materiel); $i++) {
	//$detailsExecution .= $materiel[$i][0] . "\r\n";
	$cycles[$materiel[$i][0]] = 0;
}

// Cycles : liste lue  partir du fichier CyclesOUT.txt
if (is_readable ( './CyclesOUT.txt' ))
{
	$cycles = unserialize ( urldecode ( file_get_contents (  './CyclesOUT.txt' ) ) );
}
//fseek($cyclesOut, 0); // On remet le curseur au dbut du fichier
//fclose($cyclesOut);

//ouverture du journal des sauvegardes
$journal=fopen('./Journal.txt', 'a+');
fputs($journal, '//////////////////////////////////////////'. "\n");
fputs($journal, "cycle du " . date("d/m/Y H:i:s") . "\n");
fputs($journal, '//////////////////////////////////////////'. "\n");

//cration du sous-dossier pour download des fichiers 
if(!is_dir('./' . $dwnload )){ 
	if (!mkdir('./' . $dwnload ,0777,true)){
			fputs($journal, '***Cration sous-dossier download ' . $dwnload . " : ECHEC \n");
			fputs($journal, "***Abandon du programme \n");
			$detailsExecutionErreurs .= 'ERREUR : Cration sous-dossier download ' . $dwnload . ' : ECHEC'. "\r\n";
			$detailsExecutionErreurs .= "Abandon du programme. \r\n";
			$erreurs=true;
			goto fin;
		} else {
			fputs($journal, ' Cration sous-dossier download "' . $dwnload . '" : OK'. "\n");
		}
} else {
	fputs($journal, ' Sous-dossier download "' . $dwnload . '" dj existant.'. "\n");
}


////////////////////////////////////////////
//boucle principale                       //
////////////////////////////////////////////
$d= date("Ymd");
//traitement pour chaque matriel rfrenc
for ($i = 0; $i < count($materiel); $i++) { 
	$nommat=$materiel[$i][0];
	$typmat=$materiel[$i][1];
	$ipmat=$materiel[$i][2];
	$portmat=$materiel[$i][3];
	$securemat=$materiel[$i][4];
	$usermat=$materiel[$i][5];
	$pwdmat=$materiel[$i][6];
	$retention=$materiel[$i][7];
	if ($securemat==true){
		$materiel_secure=$usermat . ':' . $pwdmat . '@';
	} else {
		$materiel_secure='';
	}
	
	$nberreurs=0; //gestionnaire d'erreurs par matriel 
	
	//entte matriel dans le journal
	fputs($journal, '============== ' . $nommat . '(' . $typmat . ') =============='. "\n");
	
	//cration du sous-dossier destination pour ce matriel
	$do=$destination . '/' . $nommat;
	$er = "Cration sous-dossier '" . $do . "'";
	if(!is_dir($do)){
		if (!mkdir($do,0777,true)){
			fputs($journal, " ***" . $er. " : ECHEC \n");
			$detailsExecutionErreurs .= "ERREUR : " . $er . " : ECHEC \r\n";
			fputs($journal, " ***Sauvegarde ignore. \n");
			$detailsExecutionErreurs .= "Sauvegarde ignore  \r\n";
			$erreurs=true;
			goto MaterielSuivant;
		} else {
			fputs($journal, " " . $er . "' : OK". "\n");
		}
	} else {
		fputs($journal, " Sous-dossier '" . $do . "' dj existant.". "\n");
	}

	//dtermination jeu de sauvegarde
	$jeu=$cycles[$nommat];
	$jeu += 1;
	if ($jeu > $retention && $retention>0) {
		$jeu=1;
	}
	//cration du sous-dossier destination selon jeu de sauvegarde
	$do=$destination . '/' . $nommat . '/' . $jeu;
	$er='Cration du dossier de destination "' . $do;
	if(!is_dir($do)){
		//cration dossier destination Jeu de ce matriel
		if (!mkdir($do ,0777,true)){
			//chec cration
			fputs($journal,' ***' . $er . '" en chec.' . "\n");
			fputs($journal,' ***sauvegarde ignore.'. "\n");
			$detailsExecutionErreurs .= 'ERREUR : ' . $er .  '" en chec.' . "\r\n";
			$detailsExecutionErreurs .= "sauvegarde ignore. \r\n";
			$erreurs=true;
			goto MaterielSuivant;
		} else {
			//cration russie
			fputs($journal,' cration du dossier de destination "' . $do . '" russie.'. "\n");
		}
	} else {
		//dossier destination Jeu de ce matriel existe dj
		fputs($journal,"     Sous-dossier de destination '" . $do . "' dj existant.". "\n");
		//vidage dossier destination. "\n");
		//$ret=vidage($destination . '/' . $nommat . '/' . $jeu);
		
		$repertoire = opendir($destination . '/' . $nommat . '/' . $jeu);
		fputs($journal, "     Vidage du dossier '" . $destination . '/' . $nommat . '/' . $jeu . "'". "\n");
		$old = getcwd(); // Save the current directory
    	chdir($destination . '/' . $nommat . '/' . $jeu);
		while (false !== ($fichier = readdir($repertoire)))
			{
				$chemin = $destination . '/' . $nommat . '/' . $jeu ."/".$fichier; // On dfinit le chemin du fichier  effacer.
				// Si le fichier n'est pas un rpertoire
				if ($fichier != ".." AND $fichier != "." AND !is_dir($fichier))
				{
								
					if (!unlink($chemin)){; // On efface.
						fputs($journal, "     - Suppression du fichier " . $fichier . "' en chec\n");
						$avertissements += 1 ; //ne remet pas en cause l'intgrit du jeu de sauvegarde
						$detailsExecutionErreurs .= "Avertissement : Suppression du fichier " . $fichier . "' en chec \r\n";
						
					} else {
						fputs($journal, "     - Suppression du fichier " . $fichier . "' russie \n");
					}
				
				}
			}
		fputs($journal, "     Vidage du dossier  '" . $destination . "/" . $nommat . "/" . $jeu  . "' termin" . "\n");
		closedir($repertoire);
		chdir($old); // Restore the old working directory
	}
	
	//cration dossier $nomat pour download
	$do=$dwnload . '/' . $nommat;
	$er='Cration sous-dossier ' . $do ;
	if(!is_dir($do)){
		if (!mkdir($do,0777,true)){
			fputs($journal, ' ***' .  $do . ' : ECHEC'. "\n");
			fputs($journal, " ***Sauvegarde ignore.\n");
			$detailsExecutionErreurs .= "ERREUR : " . $er . " : ECHEC \r\n";
			$detailsExecutionErreurs .= "Sauvegarde ignore";
			$erreurs=true;
			goto MaterielSuivant;
		} else {
			fputs($journal, '     Cration sous-dossier "' . $do . '" : OK'. "\n");
		}
	} else {
		fputs($journal, '     Sous-dossier "' . $do . '" dj existant.'. "\n");
		$detailsExecutionErreurs .="Avertissement : le dossier " . $do . " existe dj \r\n";
	}



	// Boucle download des datas (boucle fichiers XML)
	$cheminMat=$fichiersXML[$typmat][0]; //lecture chemin vers fichiers xml
	if (substr($cheminMat, 0,1)!=="/"){$cheminMat="/".$cheminMat;}
	if (substr($cheminMat, -1)!=='/'){$cheminMat=$cheminMat . '/';}
	
	for ($j = 1; $j < count($fichiersXML[$typmat]); $j++) {
		$dwnFic=false; //gestionnaire d'erreur au niveau du fichier
		$fic=$fichiersXML[$typmat][$j];
		$RenameSource = getcwd() . "/" . $dwnload . '/' . $nommat . '/' . $fic . '_' . $d . '.xml';
		$RenameDest = $destination . '/' . $nommat . '/' . $jeu . '/' . $fic . '_' . $d . '.xml';
		//dwnload du fichier source
		//echo $fic . "\r\n" . $RenameSource . "\r\n" . $RenameDest . "\r\n" . $fichiersXML[$typmat][$j] . "\r\n";
		$ficcible=fopen ('./' . $dwnload . '/' . $nommat . '/' . $fic . '_' . $d . '.xml', 'w+');
		$url = curl_init('http://' . $materiel_secure . $ipmat . ':' . $portmat .  $cheminMat . $fic . '.xml');
		curl_setopt($url, CURLOPT_TIMEOUT, 50);
		curl_setopt($url, CURLOPT_FILE, $ficcible);
		curl_setopt($url, CURLOPT_FOLLOWLOCATION, true);
		if (curl_exec($url)){
				fputs($journal, '     Download du fichier http://' . $materiel_secure . $ipmat . ':' . $portmat  .  $cheminMat . $fic . '.xml' . ' vers ' . $RenameSource . ' russi.'. "\n");
				
				$dwnFic=true;
		} else {
				fputs($journal, '    *Download du fichier http://' . $materiel_secure . $ipmat . ':' . $portmat  .  $cheminMat . $fic . '.xml vers ' . $RenameSource . ' en chec'. "\n");
				$detailsExecutionErreurs .= '    ERREUR : Download du fichier http://' . $materiel_secure . $ipmat . ':' . $portmat  .  $cheminMat . $fic . '.xml vers ' . $RenameSource . ' en chec'. "\r\n";
				$erreurs=true;
				$nberreurs += 1;
		}
		curl_close($url);
		fclose($ficcible);
		
		if (filesize ( './' . $dwnload . '/' . $nommat . '/' . $fic . '_' . $d . '.xml' )<100){
			echo "le fichier " . './' . $dwnload . '/' . $nommat . '/' . $fic . '_' . $d . '.xml' . " semble corrompu ! <br>";
			$detailsExecutionErreurs .= "le fichier " . './' . $dwnload . '/' . $nommat . '/' . $fic . '_' . $d . '.xml' . " semble corrompu ! \r\n";
				fputs($journal, "    *le fichier " . './' . $dwnload . '/' . $nommat . '/' . $fic . '_' . $d . ".xml semble corrompu ! \n");
				}
		
		//dplacement du fichier vers sa destination finale si dwnl ok
		if ($dwnFic==true){
			if (!rename($RenameSource, $RenameDest)){
				// le dplacement a chou
				fputs($journal,'    *Dplacement du fichier ' . $renameSource . ' vers ' . $RenameDest . ' en chec.'. "\n");
				$detailsExecutionErreurs .= "    ERREUR : Dplacement du fichier " . $renameSource . " vers " . $RenameDest . " en chec. \r\n";
				$erreurs=true;
				$nberreurs += 1;		
			} else {
				// le dplacement a chou
				fputs($journal,'     Dplacement du fichier ' . $RenameSource . ' vers ' . $RenameDest . ' russi.'. "\n");
			}
		} else {
			//supprime fichier cr  blanc si download chou
			//unlink('./' . $dwnload . '/' . $nommat . '/' . $fic . '_' . $d . '.xml');
		}
	}
	// sauvegarde du fichier de configuration (fichier .gce)
		$cheminMat=$fichiersConfig[$typmat][0]; //lecture chemin vers fichiers config
		if (substr($cheminMat, 0,1)!=="/"){$cheminMat="/".$cheminMat;}
		if (substr($cheminMat, -1)!=='/'){$cheminMat=$cheminMat . '/';}
		$dwnFic=false; //gestionnaire d'erreur au niveau du fichier
		$fic=$fichiersConfig[$typmat][1];
		$extension=$fichiersConfig[$typmat][2];
		$RenameSource=getcwd() . "/" . $dwnload . '/' . $nommat . '/' . $fic . '_' . $d . '.' . $extension;
		$RenameDest=$destination . '/' . $nommat . '/' . $jeu . '/' . $fic . '_' . $d . '.' . $extension;
		//upload du fichier source
		$ficcible=fopen ('./' . $dwnload . '/' . $nommat . '/' . $fic . '_' . $d . '.' . $extension, 'w+');
		$url = curl_init('http://' . $materiel_secure . $ipmat . ':' . $portmat .  $cheminMat . $fic . '.' . $extension);
		curl_setopt($url, CURLOPT_TIMEOUT, 50);
		curl_setopt($url, CURLOPT_FILE, $ficcible);
		curl_setopt($url, CURLOPT_FOLLOWLOCATION, true);
		if (curl_exec($url)){
				fputs($journal, '     Download du fichier http://' . $materiel_secure . $ipmat . ':' . $portmat .  $cheminMat . $fic . '.' . $extension .  " vers " . $RenameSource . " russi\n");
				$dwnFic=true;
		} else {
				fputs($journal, '    *Download du fichier ' . 'http://' . $materiel_secure . $ipmat . ':' . $portmat . $cheminMat . $fic . '.' . $extension .  ' vers ' . $RenameSource . " en chec \n");
				$detailsExecutionErreurs .= '    ERREUR : Download du fichier http://' . $materiel_secure . $ipmat . ':' . $portmat . $cheminMat . $fic . '.' . $extension .  ' vers ' . $RenameSource . " en chec\r\n";
				$erreurs=true;
				$nberreurs += 1;
		}
		curl_close($url);
		fclose($ficcible);
		
		if (filesize ( './' . $dwnload . '/' . $nommat . '/' . $fic . '_' . $d . '.' . $extension )<100){
			echo "le fichier " . './' . $dwnload . '/' . $nommat . '/' . $fic . '_' . $d . '.' . $extension . " semble corrompu ! <br>";
				$detailsExecutionErreurs .= "le fichier " . './' . $dwnload . '/' . $nommat . '/' . $fic . '_' . $d . '.' . $extension . " semble corrompu ! \r\n";
				fputs($journal, "    *le fichier " . './' . $dwnload . '/' . $nommat . '/' . $fic . '_' . $d . '.' . $extension . " semble corrompu ! \n");
				}
		
		if ($dwnFic==true){
			//dplacement du fichier vers sa destination finale
			if (!rename($RenameSource, $RenameDest)){
				// le dplacement a chou
				fputs($journal,'    *Dplacement du fichier ' . $RenameSource .  " vers " . $RenameDest . "en chec.\n");
				$detailsExecutionErreurs .= '    ERREUR : Dplacement du fichier ' . $RenameSource .  " vers " . $RenameDest . "en chec.\r\n";
				$erreurs=true;
				$nberreurs += 1;		
			} else {
				// le dplacement a chou
				fputs($journal,'     Dplacement du fichier ' . $RenameSource . " vers " . $RenameDest . " russi. \n");
			}
		} else {
			//supprime fichier cr  blanc si download chou
			unlink('./' . $dwnload . '/' . $nommat . '/' . $fic . '_' . $d . '.' . $extension);
		}

MaterielSuivant:
		//incrment du jeu de sauvegarde si sauvegarde complte
		if ($nberreurs==0 || $preserveIncomplets==true){
			$cycles[$nommat]=$jeu;
		}
		if ($nberreurs==0 ){
			$ficOK=fopen ($destination . '/' . $nommat . '/' . $jeu . '/Sauvegarde_complete.txt', 'w+');
			fclose($ficOK);
		} else {
			$ficOK=fopen ($destination . '/' . $nommat . '/' . $jeu . '/Sauvegarde_partielle.txt', 'w+');
			fclose($ficOK);
		}
		
		// matriel suivant
	}

fin:
	// criture cyclesOut.txt	
	file_put_contents ( './CyclesOUT.txt' , urlencode ( serialize ( $cycles ) ) );
	
	// conclusion cycle de sauvegarde dans le $journal
	fputs($journal,'     -------------------------------------------------------'. "\n");
	if ($erreurs==true){
		fputs($journal,'     Le cycle de sauvegarde a rencontr des problmes. Lisez ce qui prcde.'. "\n");
	} else if ($avertissements>0) {
		fputs($journal,'     Cycle de sauvegarde termin avec des avertissements. Lisez ce qui prcde.'. "\n");
	} else {
		fputs($journal,'     Le cycle de sauvegarde termin normalement.'. "\n");
	}
	fputs($journal,'     -------------------------------------------------------'. "\n");
	
	fclose($journal);
	
	// faonnage des dtails d'excution
	$detailsExecutionErreurs =  "===================================== \r\nRESUME DU CYCLE DE SAUVEGARDE DU JOUR : \r\n===================================== \r\n" . $detailsExecutionErreurs;
	$detailsExecutionErreurs .=  "===================================== \r\nJEUX DE SAUVEGARDE VALIDES DU JOUR : \r\n===================================== \r\n";
	for ($i = 0; $i < count($materiel); $i++) 
	{
		$detailsExecutionErreurs .=  'Materiel :  ' . $materiel[$i][0]  . " : Jeu ";
		echo 'Materiel :  ' . $materiel[$i][0]  . " : Jeu ";
		$detailsExecutionErreurs .=  $cycles[$materiel[$i][0]] . "\r\n";
		echo  $cycles[$materiel[$i][0]] . "<br>";
	}
	
	
	// en cas d'erreur,  le synology envoie une notification par mail
	if ($NotificationsMail==true && ($erreurs==true || $NotificationsLimitees==false))
		{
		//trigger_error("Au moins une erreur est survenue. Merci de consulter le journal de l'application.", E_ERROR);
		 echo "Traitement termin avec des erreurs. Veuillez consulter le journal de l'application." ;
		 mail($NotificationsDestinataire, "Sauvegarde Automatique GCE", "Au moins une erreur est survenue. Veuillez consulter le journal de l application.\r\n" . $detailsExecutionErreurs);
		}

?>